/********************************************************************/
/*                                                                  */
/*  NAME : HD61700 DISASSEMBLER HEADDER CODE                        */
/*  FILE : DA61700.h                                                */
/*  Copyright (c)  'BLUE' 2003-2021                             */
/*                                                                  */
/*  REVISION HISTORY:                                               */
/*  Rev : 0.00 2003.03.27  JJn                                 */
/*  Rev : 0.01 2003.04.10  ŏ̃o[W                         */
/*  Rev : 0.06 2003.04.25  TSWX^Ήǉ                     */
/*  Rev : 0.07 2003.05.21  BMPwb_ǉ                          */
/*  Rev : 0.10 2003.07.25  BMPp}Nǉ                    */
/*  Rev : 0.11 2003.07.29  BMPwb_C                        */
/*  Rev : 0.14 2006.06.07  Rev0.14 ܂ŏC                     */
/*  Rev : 0.18 2006.08.27  背WX^( $(SX/SY/SZ) )\ɑΉ    */
/*  Rev : 0.19 2006.09.01  背WX^( $SX/$SY/$SZ )\ɕύX  */
/*  Rev : 0.21 2006.09.28  WX^e[uC(KY)               */
/*  Rev : 0.23 2007.02.25  WX^̂C(TSIB)               */
/*  Rev : 0.27 2021.07.11  unsigned long -> unsigned int ɕύX     */
/*                         unsigned int-> unsigned int ɕύX       */
/*  Rev : 0.28 2022.04.23  SA^߂T|[g                     */
/*                         Rgo͋@\\ǉ           */
/*                         xe[uQƃtOǉ             */
/*                                                                  */
/********************************************************************/
#define	_Support_SA	1				/* 1:SA^߂T|[g       */
#define FORDOS  	0				/* 1:DOSpɃRpC      */
/*------------------------------------------------------------------*/
/*  萔`                                                        */
/*------------------------------------------------------------------*/
#define		MAXNAME		8			/* xő咷                 */
#define		MAXLEN		32			/* Iyhő咷             */
#define		MAXOPR		4			/* Iyh               */
#define		MAXLINE		256			/* PsőoCg             */
#define		MAXMN		32			/* jjbNő咷(32)     */
#if FORDOS
#define		MAXLBL		8			/* xő咷(8)          */
#else
#define		MAXLBL		16			/* xő咷(16)         */
#endif
#define		MAXCOMM		80			/* commentő咷(80)        */

/*------------------------------------------------------------------*/
/*  \͌ʏo̓e[u\̒`iOutTblj                    */
/*------------------------------------------------------------------*/
typedef struct outtbl {
	unsigned int adr;				/* ߊi[AhX             */
	unsigned int byte;				/* ߃oCg(0:Rĝ) */
	unsigned char  code[8];			/* ߃R[h                   */
	char  label[MAXLBL+2];			/* x                   */
	char  mn[MAXMN];				/* jjbN                   */
	char  opr[5][MAXMN+2];			/* Iyh                   */
	char  comment[MAXCOMM+2];		/* Rg                     */
} OUTTBL;

/*------------------------------------------------------------------*/
/*  xe[u\̒`ilbltblj                              */
/*------------------------------------------------------------------*/
typedef struct lbl {
	void * np;						/* x\̃|C^       */
	unsigned int adr;				/* ΉAhX                 */
	unsigned int flag;				/* tO(1:QƂ)       */
	char	name[MAXLBL+2];			/* x(1Byteȏ)        */
	char  comment[1];				/* Rg(1Byteȏ)          */
} LBL;
#if _Support_SA
/*------------------------------------------------------------------*/
/*  SA^ߍ\̒`iSetAreaTblj                              */
/*------------------------------------------------------------------*/
typedef struct SetAreaTbl {
	void * np;						/* SA\̃|C^           */
	unsigned char type;				/* f[^^Cv                 */
	unsigned int adr;				/* JnAhX                 */
	unsigned int byte;				/* ̈oCg(0:Rĝ) */
	unsigned int div;				/* ̈̕ALڂ   */
} SATBL;

/* f[^^Cv` */
enum{
	SA_DB	=	0	,				/* ʏ(Byte)                   */
	SA_DW			,				/* [h(word)                 */
	SA_STR			,				/* (ASCII)                */
	SA_BIN							/* oCi(2i)              */
};
#endif /* _Support_SA */

/*------------------------------------------------------------------*/
/*  ef[^ϊe[u\̒`                                */
/*------------------------------------------------------------------*/
/* #if`#else`#endif}Nϊe[u */
#define		IFLEVEL     255         /* #iflXgx */
#define		OP_IF		0			/* #if   */
#define		OP_ELSE		1			/* #else */
#define		OP_ENDIF	2			/* #endif*/

#define		LBLOK		0x000d		/* ʃx AhXς  */
#define		LBLNG		0x000e		/* ʃx AhX    */

/* Iyhϊe[u\ */
typedef struct opr {
	unsigned int code;				/* IyhR[hԍ         */
	char	name[9];				/* Iyh               */
} OPR;

#define		MACDIR		3
struct opr MacTbl[MACDIR] = {
{	OP_IF		,	"#IF"		},
{	OP_ELSE		,	"#ELSE"		},
{	OP_ENDIF	,	"#ENDIF"	}
};

/* WX^/tOgpߓo^e[u\ */
typedef struct irfnc {
	char	name[MAXMN];
} IRFNC;

struct irfnc Calc[16] = {
{	"ADC"	},
{	"SBC"	},
{	"LD"	},
{	"LDC"	},
{	"ANC"	},
{	"NAC"	},
{	"ORC"	},
{	"XRC"	},
{	"AD"	},
{	"SB"	},
{	"ADB"	},
{	"SBB"	},
{	"AN"	},
{	"NA"	},
{	"OR"	},
{	"XR"	}
};

struct irfnc Calc2[2] = {
{	"ADBCM"	},
{	"SBBCM"	}
};

struct irfnc Calc3[2] = {
{	"ADBM"	},
{	"SBBM"	}
};

struct irfnc Calc4[4] = {
{	"ADC"	},
{	"SBC"	},
{	"AD"	},
{	"SB"	}
};

struct irfnc reg[3] = {
{	"$31"	},
{	"$30"	},
{	"$0"	}
};

struct irfnc sreg[3] = {
{	"$SX"	},
{	"$SY"	},
{	"$SZ"	}
};

struct irfnc sreg2[3] = {
{	"SX"	},
{	"SY"	},
{	"SZ"	}
};

struct irfnc trans[8] = {
{	"ST"	},
{	"STI"	},
{	"STD"	},
{	"???"	},
{	"LD"	},
{	"LDI"	},
{	"LDD"	},
{	"???"	}
};

struct irfnc flags[7] = {
{	"Z"		},
{	"NC"	},
{	"LZ"	},
{	"UZ"	},
{	"NZ"	},
{	"C"		},
{	"NLZ"	}
};

struct irfnc spcmd[8] = {
{	"NOP"	},
{	"CLT"	},
{	"FST"	},
{	"SLW"	},
{	"CANI"	},
{	"RTNI"	},
{	"OFF"	},
{	"TRP"	}
};

struct irfnc rcmd1[4] = {
{	"ROD"	},
{	"ROU"	},
{	"BID"	},
{	"BIU"	}
};

struct irfnc rcmd2[4] = {
{	"DID"	},
{	"DIU"	},
{	"BYD"	},
{	"BYU"	}
};

struct irfnc str1[4] = {
{	"PE"	},
{	"PD"	},
{	"IB"	},
{	"UA"	}
};

struct irfnc str2[4] = {
{	"IA"	},
{	"IE"	},
{	"??"	},
{	"TM"	}
};

struct irfnc ir1[4] = {
{	"IX"	},
{	"IY"	},
{	"IZ"	},
{	"US"	}
};
struct irfnc ir2[4] = {
{	"SS"	},
{	"KY"	},
{	"KY"	},
{	"KY"	}
};

struct irfnc cicmd[4] = {
{	"CMP"	},
{	"CMP?"	},
{	"INV"	},
{	"INV?"	}
};

struct irfnc iocmd[4] = {
{	"PO"	},
{	"PO?"	},
{	"FL"	},
{	"FL?"	}
};

/*------------------------------------------------------------------*/
/*  G[ʒ`                                                  */
/*------------------------------------------------------------------*/
#define		NORM		0			/* I                     */
#define		EOFERR		2			/* t@CI                 */
#define		LOFLOW		5			/* Ps̕I[o[   */
#define		OPOFLOW		6			/* IyhI[o[ */
#define		LBOFLOW		7			/* Ps̕I[o[   */
#define		NOORG		8			/* ORGߒ`Ȃ            */
#define		ILLOPR		12			/* IyhLq~X           */
#define		ILLDQUO		15			/* ٺð/ ُ       */
#define		DUPLBL		16			/* xLqQȏ゠     */
#define		ILLLBL		17			/* xɗpłȂ     */
#define		LBLNOENT	20			/* xo^Ȃ               */
#define		LBNOALOC	21			/* xo^Ȃ               */
#define		UNDEFOPR	22			/* Y߂Ȃ/Lq@̃~X  */
#define		OFLOW		23			/* Iyhl͈͊O         */
#define		CALERR		28			/* vZُ( 0 Z )   */
#define		IFNEST		29			/* #if`#else`#endiflXgُ */
#if _Support_SA
#define		SANOALOC	30			/* SAo^s(mNG)     */
#define		DUPADR		31			/* SAo^s(AhXd)     */
#endif /* _Support_SA */

/* G[bZ[Wϊe[u\ */
typedef struct err {
	unsigned short code;			/* R[hԍ                   */
	char	msg[32];				/* G[bZ[W(32ȓ) */
} ERR;
#if _Support_SA
#define		MAXERR		18
#else
#define		MAXERR		16
#endif /* _Support_SA */
struct err errtbl[MAXERR] = {
{	LOFLOW	    ,	"Line Length is Too Long"		},
{	OPOFLOW	    ,	"Oprand Length is Too Long"		},
{	LBOFLOW	    ,	"LABEL Length is Too Long"		},
{	NOORG	    ,	"ORG Not Entry"					},
{	ILLOPR	    ,	"Illegal Operand"				},
{	ILLDQUO	    ,	"Illegal ['']or[(]or[)]"		},
{	DUPLBL	    ,	"LABEL Already Defined"			},
{	ILLLBL	    ,	"LABEL Type Mismatch"			},
{	LBLNOENT    ,	"Undefined LABEL"				},
{	LBNOALOC    ,	"Could Not Defined LABEL"		},
{	OFLOW	    ,	"Operand Range Over"			},
{	UNDEFOPR    ,	"Operation Type Mismatch"		},
{	OFLOW	    ,	"Operand Range Over"			},
{	CALERR	    ,	"Could Not Calculate"			},
{	IFNEST	    ,	"Illegal [#if] - [#endif]"		},
#if _Support_SA
{	SANOALOC    ,	"Could Not Defined LABEL"		},
{	DUPADR	    ,	"SA Address Already Defined"	},
#endif /* _Support_SA */
{	0		    ,	"Normal"						}
};

/*------------------------------------------------------------------*/
/*  rbg}bv쐬pwb_i蔲j                          */
/*------------------------------------------------------------------*/
/* }N` */
#define	Getlong(x) (((unsigned int)ImgTbl[x+3])<<24)+(((unsigned int)ImgTbl[x+2])<<16)+(((unsigned int)ImgTbl[x+1])<<8)+((unsigned int)ImgTbl[x]&0xff)
#define	Getword(x) ((((unsigned int)ImgTbl[x+1])<<8)+(unsigned int)ImgTbl[x])
#define	Getparret(x) (((unsigned int)ImgTbl[x+2])+((unsigned int)ImgTbl[x+1])+(unsigned int)ImgTbl[x])

/* 192*32 pxcel */
unsigned char Head1[62] = {
0x42,0x4D,0x3E,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x28,0x00,
0x00,0x00,0xC0,0x00,0x00,0x00,0x20,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x00,0x00,
0x00,0x00,0x00,0x03,0x00,0x00,0xC4,0x0E,0x00,0x00,0xC4,0x0E,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x00
};
/* 192*64 pxcel */
unsigned char Head2[62] = {
0x42,0x4D,0x3E,0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x3E,0x00,0x00,0x00,0x28,0x00,
0x00,0x00,0xC0,0x00,0x00,0x00,0x40,0x00,0x00,0x00,0x01,0x00,0x01,0x00,0x00,0x00,
0x00,0x00,0x00,0x06,0x00,0x00,0xC4,0x0E,0x00,0x00,0xC4,0x0E,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x00
};
/* mono wpbg */
#define BMP_PAL_OFF		58	/* pbgʒu */
unsigned char Pmono[4] = { 0x8F,0xBF,0xBF,0x00 };
